<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 1.5 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="./">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">@@ESCET-VERSION-ENDUSER@@</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/@@ESCET-DEPLOY-FOLDER-NAME@@">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 1.5: Exercises</h1>
                    <p>
                        You will now practice what you have learned in this first module.
                        When modeling, there is generally not one correct answer, as multiple solutions are possible.
                        After you complete an exercise, an example solution is given, together with an explanation.
                    </p>

                    <h2>Exercise 1</h2>
                    <p>
                        A vending machine will give you the snack that you want, after you give it a coin (event <code>give_coin</code>).
                        If you put in an additional coin, while it is processing your order, it will reject this coin and give it back (event <code>reject_coin</code>).
                        Once the vending machine has delivered your order (event <code>deliver</code>), it will accept a next coin.
                    </p>
                    <p>
                        Model this vending machine using an automaton, by drawing it on paper.
                        First, think of appropriate events and locations.
                        Then, consider which locations should be initial and marked.
                    </p>
                    <div class="accordion" id="exercise1-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise1-solution" aria-expanded="false" aria-controls="exercise1-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise1-solution" class="accordion-collapse collapse" data-bs-parent="#exercise1-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The machine is initially waiting for a customer to enter a coin, in location <code>Waiting</code>.
                                        Once it is given a coin, it is busy getting your order and will not accept another coin, in location <code>Busy</code>.
                                        If another coin is given, the automaton goes to a third location, <code>Rejecting</code>.
                                        In real life, the machine will only be in this location for a fraction of time, as it will immediately reject the second coin once it is given.
                                    </p>
                                    <img src="images/exercise1-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 2</h2>
                    <p>
                        A coffee machine is initially waiting for an order.
                        It requires input on what type of coffee it needs to make.
                        Upon receiving an order, the coffee machine starts grinding the coffee.
                        The machine heats the water subsequently and adds the water to the grinded coffee beans to extract the coffee from the beans.
                        After delivering the coffee to the cup, the machine returns to waiting for an order.
                        An emergency stop button can be pressed to stop the coffee machine directly, independent of its current state.
                        Each time the coffee machine goes into emergency mode, it needs to be reset before it can start waiting for an order again.
                    </p>
                    <p>
                        Model this coffee machine using an automaton, by drawing it on paper.
                    </p>
                    <div class="accordion" id="exercise2-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise2-solution" aria-expanded="false" aria-controls="exercise2-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise2-solution" class="accordion-collapse collapse" data-bs-parent="#exercise2-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The coffee machine is initially waiting for customers to enter their choice.
                                        Once a choice is made, it grinds the beans, heats the water and puts the two together to extract the coffee from the beans.
                                        Appropriate events are <code>make_choice</code>, <code>start_heating</code>, <code>add_water_to_beans</code>, <code>deliver</code>, <code>emergency</code> and <code>reset</code>.
                                        Appropriate states are <code>Wait</code>, <code>Grind</code>, <code>Heat</code> and <code>Extract</code>.
                                        You can, of course, name them differently.
                                        The emergency mode is modeled using location <code>Emergency</code>.
                                        The event <code>emergency</code> leads to this location, from every location.
                                        It is also possible to push the emergency stop button while the coffee machine is in emergency mode, so a self loop edge is needed for the <code>emergency</code> event in the <code>Emergency</code> location.
                                        Appropriate marked locations are <code>Wait</code> and <code>Emergency</code> (either or both).
                                    </p>
                                    <img src="images/exercise2-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 3</h2>
                    <p>
                        Two persons, A and B, can use a bicycle.
                        Only one person can use the bicycle at a time.
                        Person A can start riding the bicycle by event <code>ride_A</code>, and similarly person B can start riding it by event <code>ride_B</code>
                        When the person riding the bicycle is done riding it, the corresponding event <code>leave_A</code> (for person A) or <code>leave_B</code> (for person B) occurs.
                    </p>
                    <p>
                        Model this bicycle using an automaton, by drawing it on paper.
                    </p>
                    <div class="accordion" id="exercise3-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise3-solution" aria-expanded="false" aria-controls="exercise3-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise3-solution" class="accordion-collapse collapse" data-bs-parent="#exercise3-accordion">
                                <div class="accordion-body">
                                    <p>
                                        It is essential that the two persons don't use the bicycle simultaneously.
                                        So, a person needs to leave the bicycle, before the other person can start riding it.
                                        A person may also leave the bicycle and then start riding it again.
                                    </p>
                                    <img src="images/exercise3-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 4</h2>
                    <p>
                        Model a counter that counts from zero to 4.
                        The <code>increment</code> event increments the counter, and the <code>decrement</code> event decrements it.
                        The counter is connected to a lamp, and it should be possible to turn the lamp on only when the counter has an even value.
                        The counter can only change value when the lamp is off.
                        Initially, the counter is zero.
                    </p>
                    <p>
                        Model this counter and lamp using an automaton without variables, by drawing it on paper.
                    </p>
                    <div class="accordion" id="exercise4-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise4-solution" aria-expanded="false" aria-controls="exercise4-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise4-solution" class="accordion-collapse collapse" data-bs-parent="#exercise4-accordion">
                                <div class="accordion-body">
                                    <img src="images/exercise4-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 5</h2>
                    <p>
                        Model again the counter and lamp from the previous exercise, by drawing it on paper, but now using variables, guards, updates, and exactly <em>two</em> locations.
                        Hint: <code>i mod j</code> returns the remainder of <code>i</code> divided by <code>j</code>.
                    </p>
                    <div class="accordion" id="exercise5-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise5-solution" aria-expanded="false" aria-controls="exercise5-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise5-solution" class="accordion-collapse collapse" data-bs-parent="#exercise5-accordion">
                                <div class="accordion-body">
                                    <p>
                                        A variable named <code>count</code> can be used for the counter, instead of five different locations.
                                        A guard <code>count mod 2 = 0</code> for the <code>turn_on</code> event then makes sure that the lamp can only be turned on when the counter value divided by two has no remainder, and thus the counter has an even value.
                                        Two locations are used to represent that the lamp is on or off.
                                        In principle, if the exercise did not force us to use two locations, we could have opted for a single location.
                                        We could then have encoded the state of the lamp with a second variable.
                                    </p>
                                    <img src="images/exercise5-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 6</h2>
                    <p>
                        A salesman at a market wants 0.45 euro for his product.
                        He starts with 5 products in stock.
                        You can pay in coins of 5 cent, 10 cent and 20 cent (denoted by events <code>pfive</code>, <code>pten</code> and <code>ptwenty</code>).
                        When you give the salesman coins, he will check whether it is enough.
                        If it is not enough, he will ask for more money (event <code>ask_more</code>).
                        If it is enough, he will get the product for you (event <code>get_product</code>).
                        While getting the product, he calculates the change (variable <code>cha</code>).
                        Once he is done and knows how much money he needs to give back, he will give the surplus amount back with the product (event <code>deliver</code>).
                    </p>
                    <p>
                        Model this interaction with the salesman, in two different situations, by drawing them on paper.
                        For both situations, include the cash amount you have (variable <code>yc</code>) and that the salesman has (variable <code>sc</code>).
                        The amount of cash in both your pocket and the salesman's pocket should be known throughout the entire interaction.
                        You start with 2.25 euro and cannot borrow money at any time, even when your pocket is empty.
                        The salesman starts with no money.
                        Also include the products in stock of the salesman (variable <code>ps</code>).
                        You may leave out marking.
                    </p>
                    <p>
                        <strong>Situation 1:</strong>
                        You give each coin directly to the salesman, and the salesman says when you gave enough.
                        Hint: Introduce an extra variable.
                    </p>
                    <div class="accordion" id="exercise6a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise6a-solution" aria-expanded="false" aria-controls="exercise6a-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise6a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise6a-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Three locations are used: <code>Paying</code>, <code>Checking</code> and <code>Getting</code>.
                                        Euro amounts are represented in cents.
                                        Besides variables <code>yc</code>, <code>sc</code>, <code>ps</code> and <code>cha</code>, an extra variable named <code>given</code> is introduced.
                                        It represents the cash amount given to the salesman for the current purchase.
                                        When delivering, variable <code>given</code> is reset to zero, to start fresh for the next purchase.
                                        You could also model it differently, for instance keeping track of the money the salesman had prior to the current purchase.
                                        But remember that the cash amounts in both your pocket and the salesman's pocket should be known throughout the entire interaction.
                                    </p>
                                    <img src="images/exercise6a-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>Situation 2:</strong>
                        You first collect your coins in your hand before you give them all to the salesman at once.
                        Hint: Introduce an extra event.
                    </p>
                    <div class="accordion" id="exercise6b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise6b-solution" aria-expanded="false" aria-controls="exercise6b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise6b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise6b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Variable <code>hand</code> represents the amount of money in your hand.
                                        The edges for collecting money in your hand can be self loops.
                                        An extra event <code>give_money</code> is introduced for giving the money to the salesman.
                                        An edge with this event is added as well.
                                    </p>
                                    <img src="images/exercise6b-solution.png">
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 7</h2>
                    <p>
                        In the previous exercises, you modeled automata on paper.
                        Now, you will model in CIF instead, and use simulation for validation.
                    </p>
                    <p>
                        <strong>7a:</strong> Model your solution to both situations of exercise 6 in CIF.
                        Then simulate the CIF models to validate them, determining whether they are correct.
                    </p>
                    <p>
                        <strong>7b:</strong> Also make CIF models of the example solutions for both situations of exercise 6.
                        If your own models are the same as those example solutions, you obviously do not have to model them again.
                    </p>
                    <div class="accordion" id="exercise7b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7b-solution" aria-expanded="false" aria-controls="exercise7b-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        CIF model for example solution to exercise 6a:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton market:
                                                event pfive, pten, ptwenty, ask_more, get_product, deliver;
                                                disc int yc = 225, sc = 0, ps = 5, given = 0, cha = 0;

                                                location Paying:
                                                    initial;
                                                    edge pfive   do yc := yc - 5,  sc := sc + 5,  given := given + 5  goto Checking;
                                                    edge pten    do yc := yc - 10, sc := sc + 10, given := given + 10 goto Checking;
                                                    edge ptwenty do yc := yc - 20, sc := sc + 20, given := given + 20 goto Checking;

                                                location Checking:
                                                    edge ask_more    when given &lt;  45                                    goto Paying;
                                                    edge get_product when given &gt;= 45 do ps := ps - 1, cha := given - 45 goto Getting;

                                                location Getting:
                                                    edge deliver do sc := sc - cha, yc := yc + cha, given := 0, cha := 0 goto Paying;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        CIF model for example solution to exercise 6b:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton market:
                                                event pfive, pten, ptwenty, give_money, ask_more, get_product, deliver;
                                                disc int yc = 225, sc = 0, ps = 5, given = 0, cha = 0, hand = 0;

                                                location Paying:
                                                    initial;
                                                    edge pfive      do hand := hand + 5;
                                                    edge pten       do hand := hand + 10;
                                                    edge ptwenty    do hand := hand + 20;
                                                    edge give_money do yc := yc - hand, sc := sc + hand, given := given + hand, hand := 0 goto Checking;

                                                location Checking:
                                                    edge ask_more    when given &lt;  45                                    goto Paying;
                                                    edge get_product when given &gt;= 45 do ps := ps - 1, cha := given - 45 goto Getting;

                                                location Getting:
                                                    edge deliver do sc := sc - cha, yc := yc + cha, given := 0, cha := 0 goto Paying;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <p>
                        <strong>7c:</strong> Using simulation of the example solutions, can you spot the problems in these models?
                        And can you adapt the models to solve the problems?
                        Hint: Think about negative values.
                    </p>
                    <div class="accordion" id="exercise7-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise7-solution" aria-expanded="false" aria-controls="exercise7-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="exercise7-solution" class="accordion-collapse collapse" data-bs-parent="#exercise7-accordion">
                                <div class="accordion-body">
                                    <p>
                                        When you do not have money or the stock is empty, you can still pay and get a product.
                                        This means you borrowed money, which was stated in exercise 6 as not being allowed.
                                        And the salesman sold products he does not have.
                                    </p>
                                    <p>
                                        You maybe did not notice this behavior when looking at the graphical representation of the automata.
                                        Thus, it is always wise to check the model's behavior using simulation.
                                    </p>
                                    <p>
                                        For situation 1, we add guards <code>yc &gt;= 5</code>, <code>yc &gt;= 10</code> and <code>yc &gt;= 20</code> to the edges with events <code>pfive</code>, <code>pten</code> and <code>ptwenty</code>, respectively.
                                        Furthermore, we add guard <code>ps &gt; 0</code> to the same three edges, to prevent giving money to the salesman when he doesn't have any products left to sell.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton market:
                                                event pfive, pten, ptwenty, ask_more, get_product, deliver;
                                                disc int yc = 225, sc = 0, ps = 5, given = 0, cha = 0;

                                                location Paying:
                                                    initial;
                                                    edge pfive   when yc >= 5,  ps > 0 do yc := yc - 5,  sc := sc + 5,  given := given + 5  goto Checking;
                                                    edge pten    when yc >= 10, ps > 0 do yc := yc - 10, sc := sc + 10, given := given + 10 goto Checking;
                                                    edge ptwenty when yc >= 20, ps > 0 do yc := yc - 20, sc := sc + 20, given := given + 20 goto Checking;

                                                location Checking:
                                                    edge ask_more    when given &lt;  45                                    goto Paying;
                                                    edge get_product when given &gt;= 45 do ps := ps - 1, cha := given - 45 goto Getting;

                                                location Getting:
                                                    edge deliver do sc := sc - cha, yc := yc + cha, given := 0, cha := 0 goto Paying;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        For situation 2, we add <code>yc - hand &gt;= 5</code>, <code>yc - hand &gt;= 10</code> and <code>yc - hand &gt;= 20</code> to the edges with events <code>pfive</code>, <code>pten</code> and <code>ptwenty</code>, respectively.
                                        Furthermore, we add guard <code>ps &gt; 0</code> to the edge with the <code>give_money</code> event, to prevent giving money to the salesman when he doesn't have any products left to sell.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton market:
                                                event pfive, pten, ptwenty, give_money, ask_more, get_product, deliver;
                                                disc int yc = 225, sc = 0, ps = 5, given = 0, cha = 0, hand = 0;

                                                location Paying:
                                                    initial;
                                                    edge pfive   when yc - hand >= 5  do hand := hand + 5;
                                                    edge pten    when yc - hand >= 10 do hand := hand + 10;
                                                    edge ptwenty when yc - hand >= 20 do hand := hand + 20;
                                                    edge give_money when ps > 0 do yc := yc - hand, sc := sc + hand, given := given + hand, hand := 0 goto Checking;

                                                location Checking:
                                                    edge ask_more    when given &lt;  45                                    goto Paying;
                                                    edge get_product when given &gt;= 45 do ps := ps - 1, cha := given - 45 goto Getting;

                                                location Getting:
                                                    edge deliver do sc := sc - cha, yc := yc + cha, given := 0, cha := 0 goto Paying;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Exercise 8</h2>
                    <p>
                        Make CIF models of the example solutions of exercises 1 through 5 and check through simulation whether they are correct.
                        If you have alternative solutions, also model those and check whether they exhibit the same behavior.
                    </p>
                    <div class="accordion" id="exercise8a-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise8a-solution" aria-expanded="false" aria-controls="exercise8a-solution">
                                    Show solution (exercise 1)
                                </button>
                            </h2>
                            <div id="exercise8a-solution" class="accordion-collapse collapse" data-bs-parent="#exercise8a-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton VendingMachine:
                                                event give_coin, reject_coin, deliver;

                                                location Waiting:
                                                    initial;
                                                    marked;
                                                    edge give_coin goto Busy;

                                                location Busy:
                                                    edge give_coin goto Rejecting;
                                                    edge deliver goto Waiting;

                                                location Rejecting:
                                                    edge reject_coin goto Busy;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="accordion" id="exercise8b-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise8b-solution" aria-expanded="false" aria-controls="exercise8b-solution">
                                    Show solution (exercise 2)
                                </button>
                            </h2>
                            <div id="exercise8b-solution" class="accordion-collapse collapse" data-bs-parent="#exercise8b-accordion">
                                <div class="accordion-body">
                                    <p>
                                        To avoid long lines, we split the event declarations over two declarations, one per line.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton CoffeeMachine:
                                                event make_choice, start_heating, add_water_to_beans, deliver;
                                                event emergency, reset;

                                                location Waiting:
                                                    initial;
                                                    marked;
                                                    edge make_choice goto Grinding;
                                                    edge emergency goto Emergency;

                                                location Grinding:
                                                    edge start_heating goto Heating;
                                                    edge emergency goto Emergency;

                                                location Heating:
                                                    edge add_water_to_beans goto Extracting;
                                                    edge emergency goto Emergency;

                                                location Extracting:
                                                    edge deliver goto Waiting;
                                                    edge emergency goto Emergency;

                                                location Emergency:
                                                    edge emergency;
                                                    edge reset goto Waiting;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="accordion" id="exercise8c-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise8c-solution" aria-expanded="false" aria-controls="exercise8c-solution">
                                    Show solution (exercise 3)
                                </button>
                            </h2>
                            <div id="exercise8c-solution" class="accordion-collapse collapse" data-bs-parent="#exercise8c-accordion">
                                <div class="accordion-body">
                                    <p>
                                        We put location <code>NotUsed</code> first.
                                        This way the initial location is listed first.
                                        It also keeps the other two locations, which are very similar, close to each other.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton Bicycle:
                                                event ride_A, ride_B, leave_A, leave_B;

                                                location NotUsed:
                                                    initial;
                                                    marked;
                                                    edge ride_A goto RidingA;
                                                    edge ride_B goto RidingB;

                                                location RidingA:
                                                    edge leave_A goto NotUsed;

                                                location RidingB:
                                                    edge leave_B goto NotUsed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="accordion" id="exercise8d-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise8d-solution" aria-expanded="false" aria-controls="exercise8d-solution">
                                    Show solution (exercise 4)
                                </button>
                            </h2>
                            <div id="exercise8d-solution" class="accordion-collapse collapse" data-bs-parent="#exercise8d-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Names in CIF may not start with a digit, so we name the locations <code>Off0</code> and not <code>0Off</code>, and so on.
                                        We put the locations where the lamp is off first, as they are similar.
                                        The locations where the lamp is on are also similar, and they are at the end.
                                        We put the edges for <code>decrement</code> first in each edge, as they go to the previous location, making the model easier to read.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton EvenLamp:
                                                event increment, decrement, turn_on, turn_off;

                                                location Off0:
                                                    initial;
                                                    marked;
                                                    edge increment goto Off1;
                                                    edge turn_on   goto On0;

                                                location Off1:
                                                    edge decrement goto Off0;
                                                    edge increment goto Off2;

                                                location Off2:
                                                    edge decrement goto Off1;
                                                    edge increment goto Off3;
                                                    edge turn_on   goto On2;

                                                location Off3:
                                                    edge decrement goto Off2;
                                                    edge increment goto Off4;

                                                location Off4:
                                                    edge decrement goto Off3;
                                                    edge turn_on   goto On4;

                                                location On0:
                                                    edge turn_off  goto Off0;

                                                location On2:
                                                    edge turn_off  goto Off2;

                                                location On4:
                                                    edge turn_off  goto Off4;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="accordion" id="exercise8e-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#exercise8e-solution" aria-expanded="false" aria-controls="exercise8e-solution">
                                    Show solution (exercise 5)
                                </button>
                            </h2>
                            <div id="exercise8e-solution" class="accordion-collapse collapse" data-bs-parent="#exercise8e-accordion">
                                <div class="accordion-body">
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            automaton EvenLamp:
                                                event increment, decrement, turn_on, turn_off;
                                                disc int count = 0;
                                                marked count = 0;

                                                location Off:
                                                    initial;
                                                    marked;
                                                    edge decrement when count &gt; 0 do count := count - 1;
                                                    edge increment when count &lt; 4 do count := count + 1;
                                                    edge turn_on   when count mod 2 = 0 goto On;

                                                location On:
                                                    edge turn_off  goto Off;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="get-started-with-cif.html">Go back to Module 1.4</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="introduction-to-the-water-lock-case.html">Proceed to Module 1.6</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
